﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using HeuristicLab.Common;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  [Serializable]
  public class Plugin : NamedHiveItem {
    [DataMember]
    public Version Version { get; set; }

    [DataMember]
    public Guid UserId { get; set; }

    [DataMember]
    public DateTime DateCreated { get; set; }

    [DataMember]
    public bool IsLocal { get; set; }

    public Plugin() { }
    protected Plugin(Plugin original, Cloner cloner) : base(original, cloner) {
      this.Version = original.Version;
      this.UserId = original.UserId;
      this.DateCreated = original.DateCreated;
      this.IsLocal = original.IsLocal;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new Plugin(this, cloner);
    }
  }
}
